// Copyright 2013 The Ebitengine Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by genkeys.go using 'go generate'. DO NOT EDIT.

//go:build !android && !ios && !js && !nintendosdk && !playstation5

package ui

import (
	"github.com/hajimehoshi/ebiten/v2/internal/glfw"
)

var uiKeyToGLFWKey = map[Key]glfw.Key{
	KeyA:              glfw.KeyA,
	KeyAltLeft:        glfw.KeyLeftAlt,
	KeyAltRight:       glfw.KeyRightAlt,
	KeyArrowDown:      glfw.KeyDown,
	KeyArrowLeft:      glfw.KeyLeft,
	KeyArrowRight:     glfw.KeyRight,
	KeyArrowUp:        glfw.KeyUp,
	KeyB:              glfw.KeyB,
	KeyBackquote:      glfw.KeyGraveAccent,
	KeyBackslash:      glfw.KeyBackslash,
	KeyBackspace:      glfw.KeyBackspace,
	KeyBracketLeft:    glfw.KeyLeftBracket,
	KeyBracketRight:   glfw.KeyRightBracket,
	KeyC:              glfw.KeyC,
	KeyCapsLock:       glfw.KeyCapsLock,
	KeyComma:          glfw.KeyComma,
	KeyContextMenu:    glfw.KeyMenu,
	KeyControlLeft:    glfw.KeyLeftControl,
	KeyControlRight:   glfw.KeyRightControl,
	KeyD:              glfw.KeyD,
	KeyDelete:         glfw.KeyDelete,
	KeyDigit0:         glfw.Key0,
	KeyDigit1:         glfw.Key1,
	KeyDigit2:         glfw.Key2,
	KeyDigit3:         glfw.Key3,
	KeyDigit4:         glfw.Key4,
	KeyDigit5:         glfw.Key5,
	KeyDigit6:         glfw.Key6,
	KeyDigit7:         glfw.Key7,
	KeyDigit8:         glfw.Key8,
	KeyDigit9:         glfw.Key9,
	KeyE:              glfw.KeyE,
	KeyEnd:            glfw.KeyEnd,
	KeyEnter:          glfw.KeyEnter,
	KeyEqual:          glfw.KeyEqual,
	KeyEscape:         glfw.KeyEscape,
	KeyF:              glfw.KeyF,
	KeyF1:             glfw.KeyF1,
	KeyF10:            glfw.KeyF10,
	KeyF11:            glfw.KeyF11,
	KeyF12:            glfw.KeyF12,
	KeyF13:            glfw.KeyF13,
	KeyF14:            glfw.KeyF14,
	KeyF15:            glfw.KeyF15,
	KeyF16:            glfw.KeyF16,
	KeyF17:            glfw.KeyF17,
	KeyF18:            glfw.KeyF18,
	KeyF19:            glfw.KeyF19,
	KeyF2:             glfw.KeyF2,
	KeyF20:            glfw.KeyF20,
	KeyF21:            glfw.KeyF21,
	KeyF22:            glfw.KeyF22,
	KeyF23:            glfw.KeyF23,
	KeyF24:            glfw.KeyF24,
	KeyF3:             glfw.KeyF3,
	KeyF4:             glfw.KeyF4,
	KeyF5:             glfw.KeyF5,
	KeyF6:             glfw.KeyF6,
	KeyF7:             glfw.KeyF7,
	KeyF8:             glfw.KeyF8,
	KeyF9:             glfw.KeyF9,
	KeyG:              glfw.KeyG,
	KeyH:              glfw.KeyH,
	KeyHome:           glfw.KeyHome,
	KeyI:              glfw.KeyI,
	KeyInsert:         glfw.KeyInsert,
	KeyIntlBackslash:  glfw.KeyWorld1,
	KeyJ:              glfw.KeyJ,
	KeyK:              glfw.KeyK,
	KeyL:              glfw.KeyL,
	KeyM:              glfw.KeyM,
	KeyMetaLeft:       glfw.KeyLeftSuper,
	KeyMetaRight:      glfw.KeyRightSuper,
	KeyMinus:          glfw.KeyMinus,
	KeyN:              glfw.KeyN,
	KeyNumLock:        glfw.KeyNumLock,
	KeyNumpad0:        glfw.KeyKP0,
	KeyNumpad1:        glfw.KeyKP1,
	KeyNumpad2:        glfw.KeyKP2,
	KeyNumpad3:        glfw.KeyKP3,
	KeyNumpad4:        glfw.KeyKP4,
	KeyNumpad5:        glfw.KeyKP5,
	KeyNumpad6:        glfw.KeyKP6,
	KeyNumpad7:        glfw.KeyKP7,
	KeyNumpad8:        glfw.KeyKP8,
	KeyNumpad9:        glfw.KeyKP9,
	KeyNumpadAdd:      glfw.KeyKPAdd,
	KeyNumpadDecimal:  glfw.KeyKPDecimal,
	KeyNumpadDivide:   glfw.KeyKPDivide,
	KeyNumpadEnter:    glfw.KeyKPEnter,
	KeyNumpadEqual:    glfw.KeyKPEqual,
	KeyNumpadMultiply: glfw.KeyKPMultiply,
	KeyNumpadSubtract: glfw.KeyKPSubtract,
	KeyO:              glfw.KeyO,
	KeyP:              glfw.KeyP,
	KeyPageDown:       glfw.KeyPageDown,
	KeyPageUp:         glfw.KeyPageUp,
	KeyPause:          glfw.KeyPause,
	KeyPeriod:         glfw.KeyPeriod,
	KeyPrintScreen:    glfw.KeyPrintScreen,
	KeyQ:              glfw.KeyQ,
	KeyQuote:          glfw.KeyApostrophe,
	KeyR:              glfw.KeyR,
	KeyS:              glfw.KeyS,
	KeyScrollLock:     glfw.KeyScrollLock,
	KeySemicolon:      glfw.KeySemicolon,
	KeyShiftLeft:      glfw.KeyLeftShift,
	KeyShiftRight:     glfw.KeyRightShift,
	KeySlash:          glfw.KeySlash,
	KeySpace:          glfw.KeySpace,
	KeyT:              glfw.KeyT,
	KeyTab:            glfw.KeyTab,
	KeyU:              glfw.KeyU,
	KeyV:              glfw.KeyV,
	KeyW:              glfw.KeyW,
	KeyX:              glfw.KeyX,
	KeyY:              glfw.KeyY,
	KeyZ:              glfw.KeyZ,
}
